﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity.APPDto.Lawyer
{
    public class LawyerArchivesDto
    {
        [DataMember]
        public string? Id { get; set; }
        [DataMember]
        public string? lawyerserviceId { get; set; }
        /// <summary>
        /// 卷宗id
        /// </summary>
        [DataMember]
        public string? jzlbxxId { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitcode { get; set; }
        /// <summary>
        /// 部门受案号
        /// </summary>
        [DataMember]
        public string? bmsah { get; set; }
        /// <summary>
        /// 律师id
        /// </summary>
        [DataMember]
        public string? lawyerId { get; set; }
        /// <summary>
        /// 律师名字
        /// </summary>
        [DataMember]
        public string? lawyerName { get; set; }
        /// <summary>
        /// 当事人姓名
        /// </summary>
        [DataMember]
        public string? party { get; set; }
        /// <summary>
        /// 当事人身份证
        /// </summary>
        [DataMember]
        public string? partycardId { get; set; }
        /// <summary>
        /// 案件名称
        /// </summary>
        [DataMember]
        public string? casename { get; set; }
        [DataMember]
        public string? secertphoto { get; set; }
        /// <summary>
        /// 授权的开始阅卷时间
        /// </summary>
        [DataMember]
        public DateTime? permissibleStartTime { get; set; }
        /// <summary>
        /// 授权的结束阅卷时间
        /// </summary>
        [DataMember]
        public DateTime? permissibleEndTime { get; set; }
        /// <summary>
        /// 时间阅卷开始时间
        /// </summary>
        [DataMember]
        public DateTime? actualStartTime { get; set; }
        /// <summary>
        /// 实际阅卷结束时间
        /// </summary>
        [DataMember]
        public DateTime? actualEndTime { get; set; }
        /// <summary>
        /// 状态 0 待查阅 1查阅中 2 已查阅
        /// </summary>
        [DataMember]
        public ushort? status { get; set; }
        /// <summary>
        /// 拷贝限制 0 未复制 1打印 2刻录 3 both
        /// </summary>
        [DataMember]
        public ushort? copyStatus { get; set; }
        /// <summary>
        /// 0 不限制 1限制打印 2 限制刻录 3全部禁止
        /// </summary>
        [DataMember]
        public ushort? copyLimit { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? remake { get; set; }
        [DataMember]
        public DateTime? createTime { get; set; }
        [DataMember]
        public string? createrId { get; set; }
        /// <summary>
        /// 已缓存的文件计数
        /// </summary>
        public int? downloadedCount { get; set; }
        /// <summary>
        /// 总的文件数计数
        /// </summary>
        public int? jwCount { get; set; }
        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;
    }
}
