﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 设备管理
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_device")]
    public class App_DeviceModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }
        
        /// <summary>
        /// 设备编号
        /// </summary>
        [DataMember]
        public string? deviceno { get; set; }

        /// <summary>
        /// 设备名称
        /// </summary>
        [DataMember]
        public string? name { get; set; }

        /// <summary>
        /// 安放位置
        /// </summary>
        [DataMember]
        public string? position { get; set; }
        

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }

        /// <summary>
        /// 设备状态：0：正常，1：离线，2：故障
        /// </summary>
        [DataMember]
        public int? state { get; set; }

        [DataMember]
        public string? createusername { get; set; }

        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;
    }
}
