﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 听证服务
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_hearing")]
    public class App_HearingModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }

        ///// <summary>
        ///// 操作人id
        ///// </summary>
        //[DataMember]
        public string? operatorId { get; set; }
        /// <summary>
        /// 操作人
        /// </summary>
        [DataMember]
        public string? operatorName { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }

        /// <summary>
        /// 律师所名称
        /// </summary>
        [DataMember]
        public string? lawyerunit { get; set; }

        /// <summary>
        /// 律师人名称
        /// </summary>
        [DataMember]
        public string? lawyeruser { get; set; }

        /// <summary>
        /// 联系方式
        /// </summary>
        [DataMember]
        public string? contact { get; set; }
        /// <summary>
        /// 预约时间
        /// </summary>
        [DataMember]
        public DateTime? reservationtime { get; set; }

        /// <summary>
        /// 同意受理时间
        /// </summary>
        [DataMember]
        public DateTime? acceptancetime { get; set; }

        /// <summary>
        /// 所在地
        /// </summary>
        [DataMember]
        public string? location { get; set; }

        /// <summary>
        /// 听证请求原因
        /// </summary>
        [DataMember]
        public string? witnessrequest { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }

        /// <summary>
        /// 预约类型
        /// </summary>
        [DataMember]
        public string? reservationId { get; set; }
        /// <summary>
        /// 接待人Id
        /// </summary>
        [DataMember]
        public string? receptionuser { get; set; }

        /// <summary>
        /// 接待人
        /// </summary>
        [DataMember]
        public string? receptionusername { get; set; }

        /// <summary>
        /// 0:待办理，1：同意 2：拒绝
        /// </summary>
        [DataMember]
        public int? state { get; set; }
        /// <summary>
        /// 拒绝原因
        /// </summary>
        [DataMember]
        public string? reason { get; set; }

        [DataMember]
        public string? createusername { get; set; }

        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;
    }
}
