﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 律师服务
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_lawyerservices")]
    public class App_LawyerServicesModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }
        /// <summary>
        /// 预约类型
        /// </summary>
        [DataMember]
        public string? reservationId { get; set; }

        /// <summary>
        /// 律师名称
        /// </summary>
        [DataMember]
        public string? name { get; set; }

        /// <summary>
        /// 手机号
        /// </summary>
        [DataMember]
        public string? phone { get; set; }

        /// <summary>
        /// 访问日期
        /// </summary>
        [DataMember]
        public DateTime? receptiontime { get; set; }

        /// <summary>
        /// 访问结束时间
        /// </summary>
        [DataMember]
        public DateTime? receptionEndtime { get; set; }

        /// <summary>
        /// 同意受理时间
        /// </summary>
        [DataMember]
        public DateTime? acceptancetime { get; set; }

        /// <summary>
        /// 访问事由
        /// </summary>
        [DataMember]
        public string? matter { get; set; }

        /// <summary>
        /// 访问对象
        /// </summary>
        [DataMember]
        public string? objectstr { get; set; }
        
        /// <summary>
        /// 接待人Id
        /// </summary>
        [DataMember]
        public string? receptionuser { get; set; }

        /// <summary>
        /// 接待人名称
        /// </summary>
        [DataMember]
        public string? receptionusername { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }
        /// <summary>
        /// 拒绝原因
        /// </summary>
        [DataMember]
        public string? reason { get; set; }

        /// <summary>
        /// 0:待办理，1：同意 ，2：拒绝 3， 结束
        /// </summary>
        [DataMember]
        public int state { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        [DataMember]
        public string? createusername { get; set; }
        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
        public string? createuserId { get; set; }


        /// <summary>
        /// 操作人id
        /// </summary>
        [DataMember]
        public string? operatorId { get; set; }
        /// <summary>
        /// 操作人
        /// </summary>
        [DataMember]
        public string? operatorName { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;

        /// <summary>
        /// 附件
        /// </summary>
        [DataMember]
        public string? annex { get; set; }
        
        /// <summary>
        /// 当事人姓名
        /// </summary>
        [DataMember]
        public string? party { get;set;}

        /// <summary>
        /// 当事人身份证
        /// </summary>
        [DataMember]
        public string? partyIDcard { get;set;}

        /// <summary>
        /// 是否法律援助
        /// </summary>
        [DataMember]
        public bool? IsLegalAid { get; set; }

        /// <summary>
        /// 法律援助图片
        /// </summary>
        [DataMember]
        public string? legalAidPhoto { get; set; }
        /// <summary>
        /// 单位证明 律师事务所证明
        /// </summary>
        public string? departmentPhoto { get; set; }
        /// <summary>
        /// 关系证明图片
        /// </summary>
        [DataMember]
        public string? relationshipProofPhoto { get; set; }
        /// <summary>
        /// 其他图片
        /// </summary>
        [DataMember]
        public string? otherPhoto { get; set; }
        [DataMember]
        public string? mandator { get; set; }
        [DataMember]
        public string? mandatorcardId { get; set; }
        [DataMember]
        public string? relationship { get; set; }
        [DataMember]
        public bool? IsAssigned { get; set; }
    }
}
