﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 预约接待
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_reception")]
    public class App_ReceptionModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }

        /// <summary>
        /// 操作人id
        /// </summary>
        [DataMember]
        public string? operatorId { get; set; }
        /// <summary>
        /// 操作人
        /// </summary>
        [DataMember]
        public string? operatorName { get; set; }
        /// <summary>
        /// 预约手机号
        /// </summary>
        [DataMember]
        public string? phone { get; set; }

        /// <summary>
        /// 预约事由
        /// </summary>
        [DataMember]
        public string? matter { get; set; }

        [DataMember]
        public string? reason { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        [DataMember]
        public DateTime? sttime { get; set; }

        /// <summary>
        /// 结束时间
        /// </summary>
        [DataMember]
        public DateTime? ettime { get; set; }

        /// <summary>
        /// 同意受理时间
        /// </summary>
        [DataMember]
        public DateTime? acceptancetime { get; set; }

        /// <summary>
        /// 会见人Id
        /// </summary>
        [DataMember]
        public string? meetwitId { get; set; }

        /// <summary>
        /// 会见人
        /// </summary>
        [DataMember]
        public string? meetwitname { get; set; }

        /// <summary>
        /// 预约类型
        /// </summary>
        [DataMember]
        public string? reservationId { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }

        /// <summary>
        /// 状态 0：待办理，1：同意，2:拒绝，3:结束
        /// </summary>
        [DataMember]
        public int state { get; set; }

        [DataMember]
        public string? createusername { get; set; }

        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;
    }
}
