﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 远程会见
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_remote")]
    public class App_RemoteModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }

        /// <summary>
        /// 操作人id
        /// </summary>
        [DataMember]
        public string? operatorId { get; set; }
        /// <summary>
        /// 操作人
        /// </summary>
        [DataMember]
        public string? operatorName { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }
        /// <summary>
        /// 手机推流地址
        /// </summary>
        [DataMember]
        public string? appurl { get; set; }

        /// <summary>
        /// 会议号
        /// </summary>
        [DataMember]
        public string? Code { get; set; }

        /// <summary>
        /// 会议名称
        /// </summary>
        [DataMember]
        public string? name { get; set; }
        /// <summary>
        /// 预约人手机号
        /// </summary>
        [DataMember]
        public string? phone { get; set; }

        [DataMember]
        public string? reason { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        [DataMember]
        public DateTime? sttime { get; set; }
        
        /// <summary>
        /// 结束时间
        /// </summary>
        [DataMember]
        public DateTime? ettime { get; set; }

        /// <summary>
        /// 同意受理时间
        /// </summary>
        [DataMember]
        public DateTime? acceptancetime { get; set; }

        /// <summary>
        /// 会见人Id
        /// </summary>
        [DataMember]
        public string? meetwitId { get; set; }

        /// <summary>
        /// 会见人
        /// </summary>
        [DataMember]
        public string? meetwitname { get; set; }

        /// <summary>
        /// 预约类型
        /// </summary>
        [DataMember]
        public string? reservationId { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }

        /// <summary>
        /// 0:待开始，1已结束,2:会议取消
        /// </summary>
        [DataMember]
        public int state { get; set; }

        [DataMember]
        public string? createusername { get; set; }

        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;
    }
}
