﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 视频举报
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_video")]
    public class App_VideoModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }
        /// <summary>
        /// 是否匿名
        /// </summary>
        [DataMember]
        public int anonymous { get; set; }

        /// <summary>
        /// 视频连接地址
        /// </summary>
        [DataMember]
        public string? videofile { get; set; }

        /// <summary>
        /// 举报原因
        /// </summary>
        [DataMember]
        public string? reporting { get; set; }

        /// <summary>
        /// 举报人联系方式
        /// </summary>
        [DataMember]
        public string? contact { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? annexurl { get; set; }

        /// <summary>
        /// 0:未处理，1：处理中 2：已处理
        /// </summary>
        [DataMember]
        public int? state { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        [DataMember]
        public string? createusername { get; set; }
        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDeleted { get; set; } = 0;
    }
}
