﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity.AppMode.Lawyer
{

    /// <summary>
    /// 卷宗文件
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("case_jzwjitem")]
    public class JZWJItem
    {
        /// <summary>
        /// 文件唯一标识
        /// </summary>
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string Id { get; set; }
        /// <summary>
        /// 卷宗目录Id
        /// </summary>
        public string? jzmlId { get; set; }
        [DataMember]
        public string wjxh { get; set; }
        [DataMember]
        /// <summary>
        /// 目录编号
        /// </summary>
        public string mlbh { get; set; }
        [DataMember]
        /// <summary>
        /// 源文件路径
        /// </summary>
        public string ywjlj { get; set; }
        [DataMember]
        /// <summary>
        /// 缩略图文件路径
        /// </summary>
        public string sltwjlj { get; set; }
        [DataMember]
        /// <summary>
        /// pdf文件路径
        /// </summary>
        public string pdfwjlj { get; set; }
        [DataMember]
        /// <summary>
        /// 图片实际显示路径！
        /// </summary>
        public string jpgwjlj { get; set; }
        [DataMember]
        /// <summary>
        /// 文件页码
        /// </summary>
        public string wjym { get; set; }
        [DataMember]
        /// <summary>
        /// 文件类型
        /// </summary>
        public string wjlx { get; set; }
        [DataMember]
        /// <summary>
        /// 
        /// </summary>
        public string wjscbz { get; set; }
        [DataMember]
        /// <summary>
        /// 文件顺序号  排序
        /// </summary>
        public string wjsxh { get; set; }
        [DataMember]
        /// <summary>
        /// 文件显示名称   第二页
        /// </summary>
        public string wjxsmc { get; set; }
        [DataMember]
        /// <summary>
        /// 卷宗编号
        /// </summary>
        public string jzbh { get; set; }
        [DataMember]
        /// <summary>
        /// 文件ocr识别状态
        /// </summary>
        public string wjocrsbzt { get; set; }
        [DataMember]
        /// <summary>
        /// 创建时间
        /// </summary>
        public string cjsj { get; set; }
        [DataMember]
        /// <summary>
        /// 上传时间
        /// </summary>
        public string time { get; set; }
        [DataMember]

        public string taskid { get; set; }
        [DataMember]
        /// <summary>
        /// 文件标识
        /// </summary>
        public string wjbs { get; set; }
        [DataMember]
        /// <summary>
        /// 标识编号
        /// </summary>
        public string bsbh { get; set; }
    }
}
