﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Entity
{
    /// <summary>
    /// 工作台
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_staging")]
    public class StagingModel
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }

        /// <summary>
        /// 跳转地址
        /// </summary>
        [DataMember]
        public string? path { get; set; }

        /// <summary>
        /// 图标地址
        /// </summary>
        [DataMember]
        public string? icon { get; set; }

        /// <summary>
        /// 颜色
        /// </summary>
        [DataMember]
        public string? color { get; set; }

        /// <summary>
        /// 名称
        /// </summary>
        [DataMember]
        public string? title { get; set; }

        /// <summary>
        /// 类型
        /// </summary>
        [DataMember]
        public string? titletype { get; set; }


        [DataMember]
        public string? username { get; set; }

        [DataMember]
        public string? userId { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

        /// <summary>
        /// 是否删除：0：未删除、1：删除
        /// </summary>
        [DataMember]
        public int? IsDelete { get; set; } = 0;
    }
}
