﻿
using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace Elight.Entity
{
    /// <summary>
    /// 用户信息表（app_sys_user）
    /// </summary>
    [DataContract]
    public class App_Sys_UserDto
    {
		/// <summary>
		/// 表里用户唯一标识符，自增长Id
		/// </summary>
		[DataMember]
        public string? Id { get; set; }

        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
		public string? unitCode { get; set; }
		/// <summary>
		/// 部门id
		/// </summary>
		[DataMember]
		public string? department { get; set; }
        /// <summary>
        /// 部门
        /// </summary>
        [DataMember]
        public string? departmentName { get; set; }
        /// <summary>
        /// 单位证明 律师事务所证明
        /// </summary>
        public string? departmentPhoto { get; set; }
        /// <summary>
        /// 密码
        /// </summary>
        [DataMember]
		public string? Password { get; set; }

		/// <summary>
		/// 名称
		/// </summary>
		[DataMember]
		public string? name { get; set; }

        /// <summary>
        /// 职务
        /// </summary>
        [DataMember]
		public string? duties { get; set; }

		/// <summary>
		/// 电话号码
		/// </summary>
		[DataMember]
		public string? phone { get; set; }

		/// <summary>
		/// 身份证号码
		/// </summary>
		[DataMember]
		public string? cardId { get; set; }
        /// <summary>
        /// 身份（检察官，律师，当事人）
        /// </summary>
        [DataMember]
        public string? identity { get; set; }
        
        /// <summary>
        /// 微信Id
        /// </summary>
        [DataMember]
		public string? wechatId { get; set; }

        /// <summary>
        /// 账号类型0：系统，1：APP
        /// </summary>
        [DataMember]
		public int? usertype { get; set; }

        /// <summary>
        /// 是否停用 0：启用，1禁用
        /// </summary>
        [DataMember]
        public int? isdeactivate { get; set; } = 0;

        /// <summary>
        /// 是否App通用：0：通用，1：不通用
        /// </summary>
        [DataMember]
		public int? becurrent { get; set; }

		/// <summary>
		/// 头像地址
		/// </summary>
		[DataMember]
		public string? photo { get; set; }

		/// <summary>
		/// 性别 0:女 1:男
		/// </summary>
		[DataMember]
		public int? sex { get; set; }

		/// <summary>
		/// 是否删除
		/// </summary>
		[DataMember]
		public int? IsDeleted { get; set; } = 0;
        /// <summary>
        /// 审核状态
        /// </summary>
        [DataMember]
        public int? audit { get; set; }
        /// <summary>
        /// 审核描述
        /// </summary>
        [DataMember]
        public string? describe { get; set; }
        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
        public string? createuserId { get; set; }
        /// <summary>
        /// 创建人
        /// </summary>
        [DataMember]
        public string? createusername { get; set; }
        /// <summary>
        /// 角色ID
        /// </summary>
        [DataMember]
        public string? roleId { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [DataMember]
        public DateTime? createtime { get; set; } = DateTime.Now;
        /// <summary>
        /// 是否接收消息
        /// </summary>
        [DataMember]
        public bool? messages { get; set; } = false;
    }
}

