﻿using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace Elight.Entity
{
    /// <summary>
    /// 部门信息
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_sys_depart")]
    public class App_Sys_DepartModel
    {
		/// <summary>
		/// 表里用户唯一标识符，自增长Id
		/// </summary>
		[DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 单位Id
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }

        /// <summary>
        /// 部门编码
        /// </summary>
        [DataMember]
		public string? departCode { get; set; }
        /// <summary>
        /// 部门名称
        /// </summary>
        [DataMember]
        public string? departname { get; set; }

        /// <summary>
        /// 部门简称
        /// </summary>
        [DataMember]
        public string? departjc { get; set; }

        /// <summary>
        /// 是否删除 0否，1是
        /// </summary>
        [DataMember]
        public int? IsDelete { get; set; } = 0;

        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        [DataMember]
        public string? createusername { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [DataMember]
        public DateTime? createtime { get; set; } = DateTime.Now;
    }
}

