﻿
using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace Elight.Entity
{
    /// <summary>
    /// 菜单管理
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_sys_menu")]
    public class App_Sys_MenuModel
    {
		/// <summary>
		/// 表里用户唯一标识符，自增长Id
		/// </summary>
		[DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 父级
        /// </summary>
        [DataMember]
        public string? pid { get; set; }

        /// <summary>
        /// 路径
        /// </summary>
        [DataMember]
		public string? path { get; set; }
        /// <summary>
        /// 菜单名称
        /// </summary>
        [DataMember]
        public string? name { get; set; }

        /// <summary>
        /// 页面组件路径
        /// </summary>
        [DataMember]
        public string? component { get; set; }

        /// <summary>
        /// 直接跳转路径
        /// </summary>
        [DataMember]
        public string? redirect { get; set; }

        /// <summary>
        /// 页面标题
        /// </summary>
        [DataMember]
        public string? title { get; set; }

        /// <summary>
        /// 图标
        /// </summary>
        [DataMember]
        public string? icon { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        [DataMember]
        public int? sortnum { get; set; }

        /// <summary>
        /// 是否删除 0否，1是
        /// </summary>
        [DataMember]
        public int? IsDelete { get; set; } = 0;

        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        [DataMember]
        public string? createusername { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [DataMember]
        public DateTime? createtime { get; set; } = DateTime.Now;
    }
}

