﻿
using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace Elight.Entity
{
    /// <summary>
    /// 角色菜单表
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_sys_rolemenu")]
    public class App_Sys_RoleMenuModel
    {
		/// <summary>
		/// 表里用户唯一标识符，自增长Id
		/// </summary>
		[DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }

        /// <summary>
        /// 角色Id
        /// </summary>
        [DataMember]
		public string? roleId { get; set; }

		/// <summary>
		/// 菜单Id
		/// </summary>
		[DataMember]
		public string? menuId { get; set; }

        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
		public string? userId { get; set; }

		/// <summary>
		/// 创建人名称
		/// </summary>
		[DataMember]
		public string? username { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        [DataMember]
        public DateTime? creationtime { get; set; } = DateTime.Now;

		/// <summary>
		/// 是否删除
		/// </summary>
		[DataMember]
		public int? IsDelete { get; set; } = 0;
    }
}

