﻿
using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace Elight.Entity
{
    /// <summary>
    /// 单位信息
    /// </summary>
    [Serializable]
    [DataContract]
    [SugarTable("app_sys_unit")]
    public class App_Sys_UnitModel
    {
		/// <summary>
		/// 表里用户唯一标识符，自增长Id
		/// </summary>
		[DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 父级
        /// </summary>
        [DataMember]
        public string? pid { get; set; }

        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
		public string? unitCode { get; set; }
        /// <summary>
        /// 单位名称
        /// </summary>
        [DataMember]
        public string? unitname { get; set; }

        /// <summary>
        /// 单位简称
        /// </summary>
        [DataMember]
        public string? unitjc { get; set; }

        /// <summary>
        /// 单位经纬度
        /// </summary>
        [DataMember]
        public string? lalon { get; set; }

        /// <summary>
        /// 是否删除 0否，1是
        /// </summary>
        [DataMember]
        public int? IsDelete { get; set; }=0;

        /// <summary>
        /// 创建人Id
        /// </summary>
        [DataMember]
        public string? createuserId { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        [DataMember]
        public string? createusername { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [DataMember]
        public DateTime? createtime { get; set; } = DateTime.Now;
    }
}

