﻿using Elight.Utility.Code;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Logic
{
    /// <summary>
    /// 听证服务
    /// </summary>
    [DataContract]
    public class App_HearingInput : Paging
    {
        [DataMember]
        [SugarColumn(IsPrimaryKey = true)]
        public string? Id { get; set; }
        /// <summary>
        /// 单位Id
        /// </summary>
        [DataMember]
        public string? unitId { get; set; }

        /// <summary>
        /// 律师所名称
        /// </summary>
        [DataMember]
        public string? lawyerunit { get; set; }

        /// <summary>
        /// 律师人名称
        /// </summary>
        [DataMember]
        public string? lawyeruser { get; set; }

        /// <summary>
        /// 联系方式
        /// </summary>
        [DataMember]
        public string? contact { get; set; }
        /// <summary>
        /// 预约时间
        /// </summary>
        [DataMember]
        public DateTime? reservationtime { get; set; }

        /// <summary>
        /// 所在地
        /// </summary>
        [DataMember]
        public string? location { get; set; }

        /// <summary>
        /// 听证请求原因
        /// </summary>
        [DataMember]
        public string? witnessrequest { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [DataMember]
        public string? notes { get; set; }

        /// <summary>
        /// 预约类型
        /// </summary>
        [DataMember]
        public string? reservationId { get; set; }
        /// <summary>
        /// 接待人
        /// </summary>
        [DataMember]
        public string? receptionuser { get; set; }

        /// <summary>
        /// 0:待办理，1：同意 2：拒绝
        /// </summary>
        [DataMember]
        public int? state { get; set; }
        /// <summary>
        /// 拒绝原因
        /// </summary>
        [DataMember]
        public string? reason { get; set; }
    }
}
