﻿using Elight.Utility.Code;
using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace Elight.Logic.SystemModel
{
    /// <summary>
    /// 用户信息表
    /// </summary>
    [DataContract]
    public class App_Sys_UserInput:Paging
    {
        /// <summary>
        /// 表里用户唯一标识符，自增长Id
        /// </summary>
        [DataMember]
        public string? Id { get; set; }

        /// <summary>
        /// 单位编码
        /// </summary>
        [DataMember]
        public string? unitCode { get; set; }

        /// <summary>
        /// 部门
        /// </summary>
        [DataMember]
        public string? department { get; set; }

        /// <summary>
        /// 密码
        /// </summary>
        [DataMember]
        public string? Password { get; set; }

        /// <summary>
        /// 名称
        /// </summary>
        [DataMember]
        public string? name { get; set; }

        /// <summary>
        /// 职务
        /// </summary>
        [DataMember]
        public string? duties { get; set; }

        /// <summary>
        /// 电话号码
        /// </summary>
        [DataMember]
        public string? phone { get; set; }

        /// <summary>
        /// 身份
        /// </summary>
        [DataMember]
        public string? identity { get; set; }

        /// <summary>
        /// 身份证号码
        /// </summary>
        [DataMember]
        public string? cardId { get; set; }

        /// <summary>
        /// 微信Id
        /// </summary>
        [DataMember]
        public string? wechatId { get; set; }

        /// <summary>
        /// 账号类型0：系统，1：APP
        /// </summary>
        [DataMember]
        public int? usertype { get; set; }

        /// <summary>
        /// 是否停用 0：启用，1禁用
        /// </summary>
        [DataMember]
        public int? isdeactivate { get; set; }

        /// <summary>
        /// 是否App通用：0：通用，1：不通用
        /// </summary>
        [DataMember]
        public int? becurrent { get; set; }

        /// <summary>
        /// 审核状态：0：通过，1：不通过，2：待审核
        /// </summary>
        [DataMember]
        public int? audit { get; set; }

        /// <summary>
        /// 头像地址
        /// </summary>
        [DataMember]
        public string? photo { get; set; }

        /// <summary>
        /// 性别 0:女 1:男
        /// </summary>
        [DataMember]
        public int? sex { get; set; }
    }
}

