﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Utility.Enum
{
    /// <summary>
    /// 系统日志等级，按照Syslog的标准，将日志等级分为八个等级
    /// </summary>
    [DataContract]
    public enum LogLevel
    {
        /// <summary>
        /// A系统不可用
        /// </summary>
        [EnumMember]
        A系统不可用 = 0,

        /// <summary>
        /// B紧急事件
        /// </summary>
        [EnumMember]
        B紧急事件 = 1,

        /// <summary>
        /// C关键事件
        /// </summary>
        [EnumMember]
        C关键事件 = 2,

        /// <summary>
        /// D错误事件
        /// </summary>
        [EnumMember]
        D错误事件 = 3,

        /// <summary>
        /// E警告事件
        /// </summary>
        [EnumMember]
        E警告事件 = 4,

        /// <summary>
        /// F重要事件
        /// </summary>
        [EnumMember]
        F重要事件 = 5,

        /// <summary>
        /// G有用信息
        /// </summary>
        [EnumMember]
        G有用信息 = 6,

        /// <summary>
        /// H调试信息
        /// </summary>
        [EnumMember]
        H调试信息 = 7
    }
}
