﻿using Elight.Utility.Code;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Elight.Utility
{
    /// <summary>
    /// The query result.
    /// </summary>
    /// <typeparam name="T">
    /// T
    /// </typeparam>
    [Serializable]
    [DataContract]
    public class QueryResult<T>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QueryResult{T}"/> class.
        /// </summary>
        /// <param name="paging">
        /// The paging.
        /// </param>
        /// <param name="data">
        /// The data.
        /// </param>
        public QueryResult(Paging paging, IList<T> data)
        {
            this.Paging = paging;
            this.Data = data;
        }

        /// <summary>
        /// 分页信息
        /// </summary>
        [DataMember]
        public Paging Paging { get; set; }

        /// <summary>
        /// 数据
        /// </summary>
        [DataMember]
        public IList<T> Data { get; set; }
    }
}
