﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;

namespace Elight.Utility.Code
{
    /// <summary>
    /// 消息
    /// </summary>
    [Serializable]
    [DataContract]
    public class Result
    {
        public static Result Success()
        {
            return new Result()
            {
                IsSucceed = true,
                Message = "操作成功"
            };
        }
        public static Result Success(dynamic data)
        {
            return new Result()
            {
                IsSucceed = true,
                Message = "操作成功",
                result=data
            };
        }
        public static Result Error(string msg= "操作失败")
        {
            return new Result()
            {
                IsSucceed = false,
                Message = msg
            };
        }
        /// <summary>
        /// 成功/失败
        /// </summary>
        [DataMember]
        public bool IsSucceed { get; set; }

        /// <summary>
        /// 消息
        /// </summary>
        [DataMember]
        public string Message { get; set; }
        /// <summary>
        /// 消息
        /// </summary>
        [DataMember]
        public dynamic result { get; set; }
    }

    /// <summary>
    /// 消息
    /// </summary>
    [Serializable]
    [DataContract]
    public class ResultData : Result
    {
        /// <summary>
        /// 数据
        /// </summary>
        [DataMember]
        public string Data { get; set; }
    }

    /// <summary>
    /// 处理结果
    /// </summary>
    /// <typeparam name="T">扩展数据</typeparam>
    [Serializable]
    [DataContract]
    public class Result<T> : Result
    {
        /// <summary>
        /// 扩展数据
        /// </summary>
        [DataMember]
        public new T result { get; set; }
    }
}
