﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace WebApplication1.Models
{
    /// <summary>
    /// 案件表
    /// </summary>
    [Serializable]
    [DataContract]
    /// <summary>
    /// 数据表
    /// </summary>
    public class Case_Info
    {
        [DataMember]
        public string case_id { get; set; }

        /// <summary>
        /// 案件名称
        /// </summary>
        [DisplayName("案件名称")]
        [DataMember]
        public string case_ajmc { get; set; }
        /// <summary>
        /// 案件类型
        /// </summary>
        [DataMember]
        public string case_ajlx { get; set; }
        /// <summary>
        /// 部门受案号
        /// </summary>
        [DisplayName("部门受案号")]
        [DataMember]
        /// 
        public string case_bmsah { get; set; }
        /// <summary>
        /// 统一受案号
        /// </summary>
        [DataMember]
        public string case_tysah { get; set; }
        /// <summary>
        /// 承办人
        /// </summary>
        [DataMember]
        public string? case_cbr { get; set; }
        /// <summary>
        /// 公开情况
        /// </summary>
        [DataMember]
        public string? case_gkqk { get; set; }
        /// <summary>
        /// 流程阶段
        /// </summary>
        [DataMember]
        public string? case_lcjd { get; set; }
        /// <summary>
        /// 受理时间
        /// </summary>
        [DataMember]
        public string? case_slrq { get; set; }
        /// <summary>
        /// 到期时间
        /// </summary>
        [DataMember]
        public string? case_dqrq { get; set; }
        /// <summary>
        /// 审查时间
        /// </summary>
        [DataMember]
        public string? case_scrq { get; set; }
        /// <summary>
        /// 删除状态
        /// </summary>
        [DataMember]
        public int isdelete { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [DataMember]
        public DateTime? case_cjsj { get; set; }
        /// <summary>
        /// 自检状态 0：待检验 1：待校正 2：已校正 
        /// </summary>
        [DataMember]
        [DisplayName("自检状态")]
        public int case_state { get; set; }
        /// <summary>
        /// 承办单位编码
        /// </summary>
        [DataMember]
        public string? case_cbdwBm { get; set; }
        /// <summary>
        /// 承办单位名称
        /// </summary>
        [DataMember]
        public string? case_cbdwMc { get; set; }
        /// <summary>
        /// 承办部门编码
        /// </summary>
        [DataMember]
        public string? case_cbbmBm { get; set; }
        /// <summary>
        /// 承办部门名称
        /// </summary>
        [DataMember]
        public string? case_cbbmMc { get; set; }
        /// <summary>
        /// 业务编码
        /// </summary>
        [DataMember]
        public string? case_ywbm { get; set; }
        /// <summary>
        /// 业务名称
        /// </summary>
        [DataMember]
        public string? case_ywmc { get; set; }
        /// <summary>
        /// 案件类别bianma
        /// </summary>
        [DataMember]
        public string? case_ajlbBm { get; set; }
        /// <summary>
        /// 案件类别名称
        /// </summary>
        [DataMember]
        public string? case_ajlbMc { get; set; }
        /// <summary>
        /// 案件状态
        /// </summary>
        [DataMember]
        public string? case_ajzt { get; set; }
        /// <summary>
        /// 预警状态
        /// </summary>
        [DataMember]
        public string? case_yjzt { get; set; }
        /// <summary>
        /// 承办检察官编码
        /// </summary>
        [DataMember]
        public string? case_cbjcgbm { get; set; }
        /// <summary>
        /// 承办检察官身份号码
        /// </summary>
        [DataMember]
        public string? case_cbjcgsfzhm { get; set; }
        /// <summary>
        /// 办结天数
        /// </summary>
        [DataMember]
        public string? case_blts { get; set; }
        /// <summary>
        /// 办结日期
        /// </summary>
        [DataMember]
        public string? case_bjrq { get; set; }
        /// <summary>
        /// 完成日期
        /// </summary>
        [DataMember]
        public string? case_wcrq { get; set; }
        /// <summary>
        /// 归档日期
        /// </summary>
        [DataMember]
        public string? case_gdrq { get; set; }
        /// <summary>
        /// 模型编码
        /// </summary>
        [DataMember]
        public string? case_mxbm { get; set; }
        /// <summary>
        /// 模型名称
        /// </summary>
        [DataMember]
        public string? case_mxmc { get; set; }
        /// <summary>
        /// 检察官身份编码
        /// </summary>
        [DataMember]
        public string? case_cbjcgsfDm { get; set; }
        /// <summary>
        /// 检察官身份
        /// </summary>
        [DataMember]
        public string? case_cbjcgsf { get; set; }
        /// <summary>
        /// 办案团队编码
        /// </summary>
        [DataMember]
        public string? case_batdbm { get; set; }
        /// <summary>
        /// 办案团队名称
        /// </summary>
        [DataMember]
        public string? case_batdmc { get; set; }
        /// <summary>
        /// 办案团队类别
        /// </summary>
        [DataMember]
        public string? case_batdlx { get; set; }
        /// <summary>
        /// 当前节点编号
        /// </summary>
        [DataMember]
        public string? case_dqjdbh { get; set; }
        /// <summary>
        /// 当前节点名称
        /// </summary>
        [DataMember]
        public string? case_dqjdmc { get; set; }


        /// <summary>
        /// 回传状态 0未开始 ，1 成功 ，2 失败
        /// </summary>

        [DataMember]
        public int? comes_back { get; set; }

        /// <summary>
        /// 错误信息
        /// </summary>
        [DataMember]
        public string message { get; set; }
    }
}
